(function() {
	var PressedKey = Indent.GetChar();	//L[
	if ("\r}:".indexOf(PressedKey) < 0) {
		return;
	}

	var BL='',SP=' ',TB='	',SL='/',BS="\\",DQ='"',QT="'",AS='*',EOL='\r',OB='{',CB='}',OP='(',CP=')',CO=':';
	String.prototype.times = function(n) { var t = BL; for (var i=0; i<n; i++) { t += this; } return t; };
	var TabWidth = ChangeTabWidth(0);	//^u
	var InsertSpace = Plugin.GetOption('Option', 'InsertSpace') == 1;	//SPACȆ}
	var IndentUnit = TB;	//CfgP
	if (InsertSpace) IndentUnit = SP.times(TabWidth);

	var LogicY = ExpandParameter('$y');
	var CurLine = GetLineStr(LogicY).replace(/[\r\n]+/, BL);
	var reCase = /^\s*(case\s|default\b).*:/;
	var isCurCase = false;
	if (PressedKey == CO && ! (isCurCase = reCase.test(CurLine))) {
		return;
	}

	var IndentCase = Plugin.GetOption('Option', 'IndentCase') == 1;	//casẽCfgs
	var OpenParenNum = 0;
	var OpenBraceNum = 0;
	var LiteralType = BL;
	var CaseList = new Array;
	for (var nLine = 1; nLine < LogicY; nLine++) {
		var sLine = GetLineStr(nLine).replace(/[\r\n]+/, BL);
		var nLen = sLine.length;
		if (nLen == 0) continue;
		var aLine = sLine.split(BL);
		var c = BL, c2 = BL;
		for (var x = 0; x<nLen; x++) {
			c = aLine[x];
			c2 = x + 1 < nLen ? aLine[x+1] : BL;
			if (LiteralType != BL) {	//e
				if (c != LiteralType) {
					if (c == BS) { x++; continue; }
					var flag = false;
					switch (LiteralType) {
						case AS:
							var end = sLine.indexOf('*/', x+1);
							if (end >= 0) x = end-1;	//RgI܂ŃXLbv
							else flag = true;
							break;
						case DQ:
						case QT:
							var end = sLine.indexOf(LiteralType, x+1);
							if (end >= 0 && aLine[end-1] != BS) x = end-1;	//eI܂ŃXLbv
							break;
					}
					if (flag) break;
				} else {
					if (c == DQ || c == QT || c == SL) {
						LiteralType = BL;
					} else {
						if (c == AS && c2 == SL) {
							LiteralType = BL; x++;
						}
					}
				}
			} else {	//eO
				switch (c) {
					case OB:	OpenBraceNum++; break;
					case CB:
						OpenBraceNum--;
						while (CaseList[CaseList.length-1] > OpenBraceNum)
							CaseList.pop();
						break;
					case OP:	OpenParenNum++; break;
					case CP:	OpenParenNum--; break;
					case DQ:	LiteralType = DQ; break;
					case QT:	LiteralType = QT; break;
					case SL:
						if (c2 == AS) {
							LiteralType = AS; x++;
						} else if (c2 == SL) {
							LiteralType = EOL; x++;
						} else {
							LiteralType = SL;
						}
						break;
				}
				if (LiteralType == EOL) break;	//sRg͔藣E
			}
		}
		if (IndentCase && reCase.test(sLine)) {
			if (CaseList.length == 0 || CaseList[CaseList.length-1] < OpenBraceNum) {
				CaseList.push(OpenBraceNum);
			}
		}
		if (LiteralType == EOL) {
			LiteralType = BL;
		}
		if (LiteralType == SL) {
			LiteralType = BL;
		}
	}
	if (IndentCase && isCurCase) {
		if (CaseList.length == 0 || CaseList[CaseList.length-1] < OpenBraceNum) {
			CaseList.push(OpenBraceNum);
		}
	}

	var indent = 0;
	switch (PressedKey) {
		case EOL:
			var nLayoutX = 0;
			var nLen = CurLine.length;
			for (var i=0; i<nLen; i++) {
				var c = CurLine.charAt(i);
				if (c == SP) {
					nLayoutX++;
				} else if (c == TB) {
					nLayoutX += TabWidth - (nLayoutX % TabWidth);
				} else break;
			}
			indent = OpenBraceNum - (nLayoutX / TabWidth) + CaseList.length;
			if (indent > 0)
				InsText(IndentUnit.times(indent));
			break;
		case CB:
			if (/^\s*}\s*([^}]|$)/.test(CurLine)) {
				OpenBraceNum--;
				while (CaseList[CaseList.length-1] > OpenBraceNum)
					CaseList.pop();
				indent = OpenBraceNum + CaseList.length;
				GoLineTop();
				GoLineTop_Sel();
				InsText(IndentUnit.times(indent));
				Right();
			}
			break;
		case CO:
			if (isCurCase) {
				indent = OpenBraceNum + CaseList.length -1;
				GoLineTop();
				GoLineTop_Sel();
				InsText(IndentUnit.times(indent));
				GoLineEnd();
			}
			break;
	}
})();
